UIPanelWindows["CosmosFeatureFrame"] = { area = "left",	pushable = 10 };

function ToggleCosmosFeatureFrame()
	if (CosmosFeatureFrame:IsVisible()) then
		HideUIPanel(CosmosFeatureFrame);
	else
		ShowUIPanel(CosmosFeatureFrame);
	end
end

function CosmosButton_OnHide()
	UpdateMicroButtons();
	PlaySound("igSpellBookClose");
end

function CosmosButtons_UpdateColor()
	for id, value in CosmosMaster_Buttons do
		local test_function = value[CSM_TESTFUNCTION];
		if (test_function ~= nil) then
			local icon = getglobal("CosmosFeaturesButton"..id);
			local iconTexture = getglobal("CosmosFeaturesButton"..id.."IconTexture");
			
			if (test_function() == false) then
				icon:Disable();
				iconTexture:SetVertexColor(1.00, 0.00, 0.00);
			else
				icon:Enable();
				iconTexture:SetVertexColor(1.00, 1.00, 1.00);
			end
		end
	end
end

function CosmosButton_OnShow()
	UpdateMicroButtons();
	CosmosFeaturesTitleText:SetText(TEXT(COSMOS_FEATURES_TITLE));
	PlaySound("igSpellBookOpen");
	CosmosButtons_UpdateColor();
end

function CosmosButton_OnEnter()	
	for id, value in CosmosMaster_Buttons do
		if (this:GetID() == id) then
			CosmosTooltip:SetOwner(this, "ANCHOR_RIGHT");
			CosmosTooltip:SetText(value[CSM_LONGDESCRIPTION], 1.0, 1.0, 1.0);
			return;
		end
	end
end

function CosmosButton_OnClick()	
	for id, value in CosmosMaster_Buttons do
		if (this:GetID() == id) then
			local f = value[CSM_CALLBACK];
			this:SetChecked(0);
			f();
			return;
		end
	end
end

function CosmosButton_UpdateButton()
	for i = 1, 14, 1 do
		local icon = getglobal("CosmosFeaturesButton"..i);
		local iconTexture = getglobal("CosmosFeaturesButton"..i.."IconTexture");
		local iconName = getglobal("CosmosFeaturesButton"..i.."Name");
		local iconDescription = getglobal("CosmosFeaturesButton"..i.."OtherName");
		
		icon:Hide();
		iconTexture:Hide();
		iconName:Hide();
		iconDescription:Hide();
	end
	for id, value in CosmosMaster_Buttons do
		local icon = getglobal("CosmosFeaturesButton"..id);
		local iconTexture = getglobal("CosmosFeaturesButton"..id.."IconTexture");
		local iconName = getglobal("CosmosFeaturesButton"..id.."Name");
		local iconDescription = getglobal("CosmosFeaturesButton"..id.."OtherName");
		
		icon:Show();
		icon:Enable();
		iconTexture:Show();
		iconTexture:SetTexture(value[CSM_ICON]);
		iconName:Show();
		iconName:SetText(value[CSM_NAME]);
		iconDescription:Show();
		iconDescription:SetText(value[CSM_DESCRIPTION]);

	end
end
