EliteTarget_ENABLE=1;
EliteTarget_TEXT="+";
EliteTarget_updateTooltip = nil;

-- TargetLevelFrame mod
function EliteTargetFrame_CheckLevel()
	if (EliteTarget_ENABLE == 1) then
		local targetLevel = UnitLevel("target");
		if ( UnitIsPlusMob("target") ) then
			TargetLevelText:SetText(targetLevel..EliteTarget_TEXT);
		end
	end
end

-- UnitFrame mouseover mod
function EliteUnitFrame_OnEnter()
	if (EliteTarget_ENABLE == 1) then
		EliteTarget_replaceElite();
	end
end



function EliteTarget_OnEvent() 
	if (EliteTarget_ENABLE == 1) then
		if ( event == "UPDATE_MOUSEOVER_UNIT" ) then
-- no need to check, it just does a gsub
--			if ( UnitExists("mouseover") ) then
				EliteTarget_replaceElite();
--			end
		end
	end
end

function EliteTarget_replaceElite()
	local originalText = GameTooltipTextLeft2:GetText();
	if (originalText ~= nil) then
		local newText = string.gsub(originalText, " Elite ", EliteTarget_TEXT.." ");
		GameTooltipTextLeft2:SetText(newText);
	end
end

function EliteTarget_Toggle(toggle)
	if(toggle == 1) then
		EliteTarget_ENABLE = 1;
	else
		EliteTarget_ENABLE = nil;
	end
end

function EliteTarget_SetText(text)
	EliteTarget_TEXT=text;
end

function EliteTarget_OnLoad()
	if(Cosmos_RegisterConfiguration) then
		Cosmos_RegisterConfiguration(
			"COS_ELITETARGET",
			"SECTION",
			ELITETARGET_SEP,
			ELITETARGET_SEP_INFO
			);
		Cosmos_RegisterConfiguration(
			"COS_ELITETARGET_SEP",
			"SEPARATOR",
			ELITETARGET_SEP,
			ELITETARGET_SEP_INFO
			);
		Cosmos_RegisterConfiguration(
			"COS_ELITETARGET_C",
			"CHECKBOX",
			ELITETARGET_ENABLE,
			ELITETARGET_ENABLE_INFO,
			EliteTarget_Toggle,
			0
			);
	else
		-- add stand alone here
	end
	HookFunction("TargetFrame_CheckLevel","EliteTargetFrame_CheckLevel","after");
	HookFunction("UnitFrame_OnEnter","EliteUnitFrame_OnEnter","after");
end