--[[

	Props: Giving a little credit to my friends

	This mod add cute mouseovers and borders to various Cosmos
	Devs and long-term testers. 
	
	- by Alexander Yoshi 2 Oct. 2004.

]]

-- Configuration variables
local COS_PROPS_ENABLE	= nil;	-- set this to non nil to enable props
local COS_PROPS_GUILD_ENABLE = nil;

PropsTooltips = {
	["Xott"] = "Thottbot Lord";
	["Thott"] = "Thottbot Lord";
	["Naarolla"] = "Mango Maniac";
	["Graby"] = "Cosmos Frenchie";
	["Vjeux"] = "Cosmos Frenchie";
	["boulay"] = "Cosmos Frenchie";
	["Sarf"] = "Cosmos Bugsquasher";
	["Fras"] = "Cosmos Bugsquasher";
};

RegisterForSave("PropsTooltips");

RareList = {
	"Thott",
	"Xott",
	"Kelthan"
};
EliteList = { 
};
Props_EmoteList = {
	"HAIL",
	"APPLAUD",
	"SALUTE"
};

-- Callback functions
function Props_Enable(toggle)
	if(toggle == 1) then 
		COS_PROPS_ENABLE = 1;
	else
		COS_PROPS_ENABLE = nil;
	end
end
-- Callback functions
function Props_GEnable(toggle)
	if(toggle == 1) then 
		COS_PROPS_GUILD_ENABLE = 1;
	else
		COS_PROPS_GUILD_ENABLE = nil;
	end
end

function Props_GameTooltip_OnHide()
	if ( not COS_PROPS_ENABLE ) then
		return;
	end
	local guild = nil;
	guild = GetGuildInfo("mouseover");
	local ttt4 = getglobal("GameTooltipTextLeft4");
	if (ttt4) then
		local text = ttt4:GetText();
		if (text and (string.find(ttt4:GetText(), "<") and string.find(ttt4:GetText(), ">"))) then
			ttt4:SetText("");
			ttt4:Hide();
		end
	end
end

function Props_OnEvent()
	if ( event == "UPDATE_MOUSEOVER_UNIT" ) then 
		if ( not COS_PROPS_ENABLE ) then
			return;
		end
		Props_ModifyTooltip(true);
	end
end

old_UnitFrame_OnEnter = UnitFrame_OnEnter;
function UnitFrame_OnEnter()
	old_UnitFrame_OnEnter();

	Props_ModifyTooltip();
end


function Props_ModifyTooltip(isMoused)
	--if ( this == TargetFrame or string.find(this:GetName(), "PartyMemberFrame") ) then
		if ( COS_PROPS_ENABLE ) then 
			if ( (GameTooltipTextLeft1:GetText() == "Alaair") or (GameTooltipTextLeft1:GetText() == "AlexYoshi") or (GameTooltipTextLeft1:GetText() == "Kelthan") ) then 
				GameTooltipTextLeft3:SetText(GameTooltipTextLeft3:GetText().." Coder");
			elseif ((GameTooltipTextLeft1:GetText() == "Thott")  or (GameTooltipTextLeft1:GetText() == "Xott") ) then 
				GameTooltipTextLeft3:SetText(GameTooltipTextLeft3:GetText().." Coder");
			elseif ((GameTooltipTextLeft1:GetText() == "Darkwing")  or (GameTooltipTextLeft1:GetText() == "Scree") ) then 
				GameTooltipTextLeft3:SetText(GameTooltipTextLeft3:GetText().." Coder");
			elseif ( GameTooltipTextLeft1:GetText() == "Snooke" ) then 
				GameTooltipTextLeft3:SetText(GameTooltipTextLeft3:GetText().." Warrior Coder");				
			end

			-- Sets your own notes
			if ( PropsTooltips[GameTooltipTextLeft1:GetText()] ) then 
				GameTooltipTextLeft2:SetText(PropsTooltips[GameTooltipTextLeft1:GetText()]);
			end

			local guild = nil;
			if (isMoused) then
				guild = GetGuildInfo("mouseover");
			else
				guild = GetGuildInfo("target");
			end
			local ttt4 = getglobal("GameTooltipTextLeft4");
			if (ttt4) then
				local text = ttt4:GetText();
				if (text and (string.find(ttt4:GetText(), "<") and string.find(ttt4:GetText(), ">"))) then
					ttt4:SetText("");
					ttt4:Hide();
				end
				if ( guild and COS_PROPS_GUILD_ENABLE ) then
					GameTooltip:SetHeight(GameTooltip:GetHeight()+16);
					ttt4:SetTextColor(1.0, 1.0, 1.0);
					ttt4:SetText("<"..guild..">");
					ttt4:Show();
					local newWidth = GameTooltip:GetWidth();
					for i = 1, 10 do
						local checkText = getglobal("GameTooltipTextLeft"..i);
						if (checkText and ((checkText:GetWidth() + 24) > newWidth)) then
							newWidth = (checkText:GetWidth() + 24);
						end
					end
					GameTooltip:SetWidth(newWidth);
				end
			end
			
		else
			-- No Labels
		end
	--end
	--
end


-- OnFoo functions

function Props_OnLoad()
	--Print("SocialSendMessage_OnLoad.");

	-- Register with the CosmosMaster
	if(Cosmos_RegisterConfiguration ~= nil) then
		Cosmos_RegisterConfiguration(
			"COS_PROPS",
			"SECTION",
			TEXT(COS_PROPS_HEADER),
			TEXT(COS_PROPS_INFO)
			);
		Cosmos_RegisterConfiguration(
			"COS_PROPS_SEPARATOR",
			"SEPARATOR",
			TEXT(COS_PROPS_HEADER),
			TEXT(COS_PROPS_INFO)
			);

		Cosmos_RegisterConfiguration(
			"COS_PROPS_ENABLE",	--CVar
			"CHECKBOX",						--Things to use
			TEXT(COS_PROPS_ENABLE_TEXT),
			TEXT(COS_PROPS_INFO),
			Props_Enable,		--Callback
			1							--Default Checked/Unchecked
			);
		Cosmos_RegisterConfiguration(
			"COS_PROPS_GENABLE",	--CVar
			"CHECKBOX",						--Things to use
			TEXT(COS_PROPS_GENABLE_TEXT),
			TEXT(COS_PROPS_GENABLE_INFO),
			Props_GEnable,		--Callback
			0							--Default Checked/Unchecked
			);
		Cosmos_RegisterChatCommand(
			"PropsAdder",
			{"/label"},
			Props_ChatCommandHandler,
			"Adds a custom title to a player's tooltip. Usage: /label PlayerName Their Title"
			);
	end
end

function Props_ChatCommandHandler (msg)
	name = string.gsub (msg, "([%w]+) (.*)", "%1");
	title = string.gsub (msg, "([%w]+) (.*)", "%2");

	if ( name ~= msg ) then 
		if ( title == "" ) then 
			title = nil;
		end
		PropsTooltips[name] = title;
	end
end
