TARGET_STATS_MIN_WIDTH = 200;
TARGET_STATS_HEIGHT = 85;

TargetStats_Enable = true;

function TargetStats_OnLoad()
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b);
	this:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
	this:SetPadding(16);
	this:SetPoint("TOPLEFT", "TargetFrame", "BOTTOMLEFT", 0, -10);

	TargetStatsTooltipDealtLabel:SetText(TARGETSTATS_AVDAMAGDEAL);
	TargetStatsTooltipTakenLabel:SetText(TARGETSTATS_AVDAMAGTAKEN);
	TargetStatsTooltipKillsLabel:SetText(TARGETSTATS_KILL);
	TargetStatsTooltipDeathsLabel:SetText(TARGETSTATS_DEATH);
end

function TargetStats_OnEvent(evevt)
	if ( KillLogFrame and KillLogFrame.IsOn == 0 ) then
		return;
	end
	if ( event == "PLAYER_TARGET_CHANGED" ) then
		TargetStats_Update();
		return;
	end
end

function TargetStats_Update()
	if ( not UnitExists("target") ) then
		HideUIPanel(TargetStatsTooltip);
	elseif ( TargetStats_Enable ) then
		local name = UnitName("target");
		local killData = KillLogByName[name];
		if ( killData ) then
			ShowUIPanel(TargetStatsTooltip);
			TargetStatsTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");

			local tooltip = killData.name;--..'\n|cffffffff';
			local count = killData.kills + killData.deaths;
			if ( count == 0 ) then
				--tooltip = tooltip..'Dmg Dealt:\n';
				TargetStatsTooltipDealtText:SetText('n/a');
				--tooltip = tooltip..'Dmg Taken:\n';
				TargetStatsTooltipTakenText:SetText('n/a');
			else
				--tooltip = tooltip..'Dmg Dealt:\n';
				TargetStatsTooltipDealtText:SetText(format('%.1f', (killData.meleeDamageToMob + killData.spellDamageToMob + killData.petDamageToMob) / count));
				--tooltip = tooltip..'Dmg Taken:\n';
				TargetStatsTooltipTakenText:SetText(format('%.1f', (killData.meleeDamageToPlayer + killData.spellDamageToPlayer + killData.petDamageToPlayer) / count));
			end
			--tooltip = tooltip..'Kills:\n';
			TargetStatsTooltipKillsText:SetText(killData.kills);
			--tooltip = tooltip..'Deaths:\n';
			TargetStatsTooltipDeathsText:SetText(killData.deaths);

			TargetStatsTooltip:SetText(tooltip);

			if ( TargetStatsTooltip:GetWidth() < TARGET_STATS_MIN_WIDTH ) then
				TargetStatsTooltip:SetWidth(TARGET_STATS_MIN_WIDTH);
			end
			TargetStatsTooltip:SetHeight(TARGET_STATS_HEIGHT);
		end
	end
end

function TargetStats_HandleEnableChange(value, checked)
	TargetStats_Enable = (checked == 1);
end
